#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
### 2007-1010 - Bandview v.0.9.0 mod by catastrophe
# - Tested for use on SmoothWall Express 3.0-polar-i386 (kernel v2.6.16.53) (update1-i386)
# - Reused some code from Bandview v.0.6.3-test2 mod by catastrophe for SWE2, not all features ported over yet.
# - Implementation of modlib v2.3 pack system by Tiago Freitas Leal and Drew S. Dupont (NetWhiz) from QoS v1.8 mod
#    with "check Smoothwall version" adapted from install script of Crontool v3.0c mod by s-t-p
# - Used ipblock.cgi from SWE3.0 by The Smoothwall Team as a CGI template
# - Uses data from /var/log/trafficstats
# - Color graph routine inspired by advstatus.cgi from SWE2/3 by The Smoothwall Team
# - GUI for adding, removing, editing users (using some code adapted from dhcp.cgi from SWE2 by The Smoothwall Team)
# - Lastupdate time and "tabbed" menu (using some code adapted from graphs.cgi from SWE2/3 by The Smoothwall Team)
# - Borrowed parts of "displaytable" subroutine from smoothtype.pm from SWE3.0 by the SmoothWall Team
# - Incorporated "DAYS USED mod" contribution by Andrew Brown (andrewb)
# - ip2number routine for sorting IP addresses adapted from the dhcppack mod for SWE2 by Tiago
### 2007-1015 - Bandview v.0.9.1 mod by catastrophe
# - Fixed "Phantom users" issue.
# - Completed ability to exclude users from red tally.
###
#
# - Disclaimer:
#    - Use at your own risk without any or implied warranty.
###


#############
###REQUIRE###
#############

use lib "/usr/lib/smoothwall";
use header qw( :standard );
#use smoothd qw( message );
#use smoothtype qw( :standard );
use POSIX qw(strftime);

use Socket;


###############
###VARIABLES###
###############

my %netsettings;
&readhash("${swroot}/ethernet/settings", \%netsettings);

my (%cgiparams,%checked,%selected);

&bandviewTABinfo();

&showhttpheaders();

my (%bandviewsettings,%checked,%selected);
$bandviewsettings{'ACTION'} = '';
$bandviewsettings{'BAND_ALLOTTED'} = '10000';
$bandviewsettings{'BAND_CALCULATEWHAT'} = 'both';
$bandviewsettings{'BAND_HIDETRIPLEZEROES'} = 'off';
$bandviewsettings{'BAND_COLUMN'} = '0';
$bandviewsettings{'BAND_REVERSE'} = 'off';
$bandviewsettings{'BAND_USERLIST'} = '/var/smoothwall/mods/bandview/preferences/bandview-userlist';
$bandviewsettings{'BAND_TABSELECTED'} = '#ffcc66';
$bandviewsettings{'BAND_TABNOTSELECTED'} = $primarynavdesel;
$bandviewsettings{'BAND_DAYSINFO'} = "on";
&getcgihash(\%bandviewsettings);

@bandviewtablabel = ("monitor","users", "raw");		###bandview tabs!

my $errormessage = '';

&bandviewUSERadd();			###add users to bandview userlist file
&bandviewUSERremoveEDIT();		###remove or edit bandview userlist file
&bandviewACTIONupdate();		###update bandview settings file

system ("/bin/touch ${swroot}/mods/bandview/preferences/bandview");			###create bandview settings file if doesn't exist
&readhash("${swroot}/mods/bandview/preferences/bandview", \%bandviewsettings);	###read in bandview settings

system ("/bin/touch ${swroot}/mods/bandview/preferences/bandview-userlist");			###create bandview userlist file if doesn't exist

$bandmax=$bandviewsettings{'BAND_ALLOTTED'};	###maximum allowed in megabytes
#$bandmax=30000; 					###maximum allowed in megabytes
$bandin=0;          ###Incoming RED
$bandout=0;         ###Outgoing RED
$bandtot=0;         ###Total RED
$bandfree=0;
$bandover=0;
$bandoverfontcolor="#ffffff";
$bandoverbgcolor="#000000";
$orangebandmax=0;
$greenbandin=0;     ###Incoming GREEN
$greenbandout=0;    ###Outgoing GREEN
$greenbandtot=0;    ###Total GREEN
$orangebandmax=0;
$orangebandin=0;    ###Incoming ORANGE
$orangebandout=0;   ###Outgoing ORANGE
$orangebandtot=0;   ###Total ORANGE
$purplebandmax=0;
$purplebandin=0;    ###Incoming purple
$purplebandout=0;   ###Outgoing purple
$purplebandtot=0;   ###Total purple
$userbandmax=$bandviewsettings{'BAND_USERCAP'};
$userbandtotalin=0;		###Incoming USER
$userbandtotalout=0;		###Outgoing USER
$userbandtotalused=0;	###Total USER

$redexbandin=0;	###Excluded Incoming RED
$redexbandout=0;	###Excluded Outgoing RED
$redexbandtot=0;	###Excluded Total RED

my %userbandtot;    ###user total
my %userbandin;     ###user in
my %userbandout;    ###user out
my %userbandover;
my %userbandper;

my %bandviewUSERS;		###user name
my %bandviewUSERScap;	###user cap
my %bandviewUSERSipaddr;	###user ip
my %bandviewUSERSinfo;	###user description

$monthdays=0;		###Days in Anniversary Month
$monthused=0;		###Days already gone
$monthleft=0;		###Days to go
$monthper=0;		###Percentage of Days gone

@daysinmonth=(31,28,31,30,31,30,31,31,30,31,30,31);	###days in month

$bandavgin=0;		###day average in (in / days already gone)
$bandavgout=0;	###day average out (out / days already gone)
$bandavgcap=0;	###day average cap (isp cap / days in anniversary month)
$bandavgused=0;	###day average used (in+out / days already gone)
$bandavgfree=0;	###day average used (isp cap-in+out / days to go)

$graphcriticalcolour = "#ff0000";
$graphwarningcolour  = "#ff5d00";
$graphnominalcolour  = "#ffa200";
$graphblankcolour    = "#ffffff";

$graphalertcritical = 90;
$graphalertwarning  = 70;

$banddivide=1024;
$bandlastupdate="";

$catgreen = "#60aa60";
$catorange = "#ff9900";
$catred = "#ff6060";
$catwhite = "#ffffff";
$catblue = "#0000ff";
$catpurple = "#800080";


##########
###MAIN###
##########

$selected{'BAND_ALLOTTED'}{'0'} = '';
$selected{'BAND_ALLOTTED'}{'500'} = '';
$selected{'BAND_ALLOTTED'}{'1000'} = '';
$selected{'BAND_ALLOTTED'}{'2000'} = '';
$selected{'BAND_ALLOTTED'}{'3000'} = '';
$selected{'BAND_ALLOTTED'}{'4000'} = '';
$selected{'BAND_ALLOTTED'}{'5000'} = '';
$selected{'BAND_ALLOTTED'}{'6000'} = '';
$selected{'BAND_ALLOTTED'}{'7000'} = '';
$selected{'BAND_ALLOTTED'}{'8000'} = '';
$selected{'BAND_ALLOTTED'}{'9000'} = '';
$selected{'BAND_ALLOTTED'}{'10000'} = '';
$selected{'BAND_ALLOTTED'}{'11000'} = '';
$selected{'BAND_ALLOTTED'}{'12000'} = '';
$selected{'BAND_ALLOTTED'}{'13000'} = '';
$selected{'BAND_ALLOTTED'}{'14000'} = '';
$selected{'BAND_ALLOTTED'}{'15000'} = '';
$selected{'BAND_ALLOTTED'}{'16000'} = '';
$selected{'BAND_ALLOTTED'}{'17000'} = '';
$selected{'BAND_ALLOTTED'}{'18000'} = '';
$selected{'BAND_ALLOTTED'}{'19000'} = '';
$selected{'BAND_ALLOTTED'}{'20000'} = '';
$selected{'BAND_ALLOTTED'}{'25000'} = '';
$selected{'BAND_ALLOTTED'}{'30000'} = '';
$selected{'BAND_ALLOTTED'}{'35000'} = '';
$selected{'BAND_ALLOTTED'}{'40000'} = '';
$selected{'BAND_ALLOTTED'}{'45000'} = '';
$selected{'BAND_ALLOTTED'}{'50000'} = '';
$selected{'BAND_ALLOTTED'}{'60000'} = '';
$selected{'BAND_ALLOTTED'}{'70000'} = '';
$selected{'BAND_ALLOTTED'}{'80000'} = '';
$selected{'BAND_ALLOTTED'}{'90000'} = '';
$selected{'BAND_ALLOTTED'}{'100000'} = '';
$selected{'BAND_ALLOTTED'}{'200000'} = '';
$selected{'BAND_ALLOTTED'}{'250000'} = '';
$selected{'BAND_ALLOTTED'}{$bandviewsettings{'BAND_ALLOTTED'}} = 'SELECTED';

$selected{'BAND_CALCULATEWHAT'}{'both'} = '';
$selected{'BAND_CALCULATEWHAT'}{'inonly'} = '';
$selected{'BAND_CALCULATEWHAT'}{'outonly'} = '';
$selected{'BAND_CALCULATEWHAT'}{$bandviewsettings{'BAND_CALCULATEWHAT'}} = 'SELECTED';

$checked{'BAND_HIDETRIPLEZEROES'}{'on'} = '';
$checked{'BAND_HIDETRIPLEZEROES'}{'off'} = '';
$checked{'BAND_HIDETRIPLEZEROES'}{$bandviewsettings{'BAND_HIDETRIPLEZEROES'}} = 'CHECKED';

$selected{'BAND_COLUMN'}{'0'} = '';
$selected{'BAND_COLUMN'}{'1'} = '';
$selected{'BAND_COLUMN'}{'2'} = '';
$selected{'BAND_COLUMN'}{'3'} = '';
$selected{'BAND_COLUMN'}{'4'} = '';
$selected{'BAND_COLUMN'}{$bandviewsettings{'BAND_COLUMN'}} = 'SELECTED';

$checked{'BAND_REVERSE'}{'on'} = '';
$checked{'BAND_REVERSE'}{'off'} = '';
$checked{'BAND_REVERSE'}{$bandviewsettings{'BAND_REVERSE'}} = 'CHECKED';

&openpage("Bandview", 1, '', 'about your smoothie');
&openbigbox('100%', 'LEFT');
&alertbox($errormessage);
&bandviewMAINmenuZERO();
&closebigbox();
&closepage($errormessage);

##########
###DONE###
##########





#################
###SUBROUTINES###
#################


sub bandviewGETDATAmonth {
	&bandviewGETusers();
	@bandview_data = `cat /var/log/trafficstats`;
#	@bandview_data = `cat /var/log/quicktrafficstats`;
	chomp (@bandview_data);
	for ($i=0; $i <= $#bandview_data; $i++){
		$band = $bandview_data[$i];
		chomp ($band);
		&bandviewDATAinterpretation();
	}
}

sub bandviewDATAinterpretation {		###data from /var/log/trafficstats
	$bandreddevi="this_month_inc_total_".$netsettings{'RED_DEV'};
	$bandreddevo="this_month_out_total_".$netsettings{'RED_DEV'};
	$bandpppdevi="this_month_inc_total_"."ppp0";
	$bandpppdevo="this_month_out_total_"."ppp0";
	$bandipppdevi="this_month_inc_total_"."ippp0";
	$bandipppdevo="this_month_out_total_"."ippp0";
	$bandgreendevi="this_month_inc_total_".$netsettings{'GREEN_DEV'};
	$bandgreendevo="this_month_out_total_".$netsettings{'GREEN_DEV'};
	$bandorangedevi="this_month_inc_total_".$netsettings{'ORANGE_DEV'};
	$bandorangedevo="this_month_out_total_".$netsettings{'ORANGE_DEV'};
	$bandpurpledevi="this_month_inc_total_".$netsettings{'PURPLE_DEV'};
	$bandpurpledevo="this_month_out_total_".$netsettings{'PURPLE_DEV'};
	if ($band =~ /^last_update/){
		chomp ($band);
		@line=split (/=/, $band);
		$bandlastupdate=$line[1];

	} elsif ($band =~ /$bandreddevi/){   ###Incoming red
		chomp ($band);
		@line=split (/=/, $band);
		$bandin=$bandin+int($line[1]/$banddivide);
	} elsif ($band =~ /$bandreddevo/){   ###Outgoing red
		chomp ($band);
		@line=split (/=/, $band);
		$bandout=$bandout+int($line[1]/$banddivide);

	} elsif ($band =~ /$bandpppdevi/){   ###Incoming ppp0 red
		chomp ($band);
		@line=split (/=/, $band);
		$bandin=$bandin+int($line[1]/$banddivide);
	} elsif ($band =~ /$bandpppdevo/){   ###Outgoing ppp0 red
		chomp ($band);
		@line=split (/=/, $band);
		$bandout=$bandout+int($line[1]/$banddivide);

	} elsif ($band =~ /$bandipppdevi/){   ###Incoming ippp0 red
		chomp ($band);
		@line=split (/=/, $band);
		$bandin=$bandin+int($line[1]/$banddivide);
	} elsif ($band =~ /$bandipppdevo/){   ###Outgoing ippp0 red
		chomp ($band);
		@line=split (/=/, $band);
		$bandout=$bandout+int($line[1]/$banddivide);

	} elsif ($band =~ /$bandgreendevi/){   ###Incoming green
		chomp ($band);
		@line=split (/=/, $band);
		$greenbandin=$greenbandin+int($line[1]/$banddivide);
	} elsif ($band =~ /$bandgreendevo/){   ###Outgoing green
		chomp ($band);
		@line=split (/=/, $band);
		$greenbandout=$greenbandout+int($line[1]/$banddivide);

	} elsif ($band =~ /$bandorangedevi/){   ###Incoming orange
		chomp ($band);
		@line=split (/=/, $band);
		$orangebandin=$orangebandin+int($line[1]/$banddivide);
	} elsif ($band =~ /$bandorangedevo/){   ###Outgoing orange
		chomp ($band);
		@line=split (/=/, $band);
		$orangebandout=$orangebandout+int($line[1]/$banddivide);

	} elsif ($band =~ /$bandpurpledevi/){   ###Incoming purple
		chomp ($band);
		@line=split (/=/, $band);
		$purplebandin=$purplebandin+int($line[1]/$banddivide);
	} elsif ($band =~ /$bandpurpledevo/){   ###Outgoing purple
		chomp ($band);
		@line=split (/=/, $band);
		$purplebandout=$purplebandout+int($line[1]/$banddivide);

	} else {
		for ($x=0; $x <= $#bandviewUSERSipaddr; $x++) {
			chomp ($bandviewUSERS[$x]);
			$banduseri="this_month_inc_total_".$bandviewUSERSipaddr[$x]." ";
			$bandusero="this_month_out_total_".$bandviewUSERSipaddr[$x]." ";
			if ($band =~ /$banduseri/){         ###user in
				chomp ($band);
				@line=split (/=/, $band);
				$userbandin[$x]=$userbandin[$x]+int($line[1]/$banddivide);
				if ($bandviewUSERSinfo[$x] eq "exclude") {
					$redexbandin=$redexbandin+int($line[1]/$banddivide);
				}
			} elsif ($band =~ /$bandusero/){   ###user out
				chomp ($band);
				@line=split (/=/, $band);
				$userbandout[$x]=$userbandout[$x]+int($line[1]/$banddivide);
				if ($bandviewUSERSinfo[$x] eq "exclude") {
					$redexbandout=$redexbandout+int($line[1]/$banddivide);
				}
			}

		}
	}
}

sub bandviewCALCULATIONSmonth {
	$bandin=$bandin-$redexbandin;   ###Excluded applied to Incoming Red
	$bandout=$bandout-$redexbandout;   ###Excluded applied to Outgoing Red
	$bandtot=$bandin+$bandout;
	if ($bandviewsettings{'BAND_CALCULATEWHAT'} eq 'inonly') {
		$bandfree=$bandmax-$bandin;
		$bandtot=$bandin
	} elsif ($bandviewsettings{'BAND_CALCULATEWHAT'} eq 'outonly') {
		$bandfree=$bandmax-$bandout;
		$bandtot=$bandout
	} else {
		$bandfree=$bandmax-$bandtot;
	}
	$greenbandtot=$greenbandin+$greenbandout;
	$orangebandtot=$orangebandin+$orangebandout;
	$purplebandtot=$purplebandin+$purplebandout;
	if ($bandmax eq 0) {
		$bandper = 0;
	} else {
		if ($bandviewsettings{'BAND_CALCULATEWHAT'} eq 'inonly') {
			$bandper = int((($bandin/$bandmax)*100));
		} elsif ($bandviewsettings{'BAND_CALCULATEWHAT'} eq 'outonly') {
			$bandper = int((($bandout/$bandmax)*100));
		} else {
			$bandper = int((($bandtot/$bandmax)*100));
		}
	}
	if ($bandper >= 100){ $bandover=$bandper-100; $bandper=100; };
}

sub bandviewPRINTmonth {
	$bandgraphper=$bandper; &bandGRAPHcolorsnow();
#	print "<table border='0' cellspacing='0' cellpadding='2'>";
#	print "<table style='width: 90%; margin-left: auto; margin-right: auto; border-collapse: collapse; border: solid 1px #c0c0c0;'>";
	print "<table style='width: 97%; margin-left: auto; margin-right: auto; border-collapse: collapse;'>";
	print qq|
	<tr>
	<th style='text-align: left; width: 50px'>Interface</th>
	<th style='text-align: right; width: 50px'>Cap</th>
	<th style='text-align: right; width: 50px'>In</th>
	<th style='text-align: right; width: 50px'>Out</th>
	<th style='text-align: right; width: 50px'>Used</th>
	<th style='text-align: right; width: 50px'>Left</th>
	<th style='text-align: right; width: 5px'>&nbsp;</th>
	<th style='text-align: center; width: 50px'>Used %</th>
	<th style='text-align: center; width: 50px'>Over %</th>
	</tr>
	|;

	###print RED###
	if ($bandmax eq 0) {
		print qq|
		<tr>
		<td align='left'><tt><font color='$catred'>RED</font>&nbsp;($netsettings{'RED_DEV'})</tt></td>
		<td align='right'><tt>-</tt><tt><font color=#666666> </font></tt></td>
		<td align='right'><tt>$bandin</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>$bandout</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>$bandtot</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>-</tt><tt><font color=#666666> </font></tt></td>
		<td><tt>&nbsp;</tt></td>
		|;
	} else {
		print qq|
		<tr>
		<td align='left'><tt><font color='$catred'>RED</font>&nbsp;($netsettings{'RED_DEV'})</tt></td>
		<td align='right'><tt>$bandmax</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>$bandin</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>$bandout</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>$bandtot</tt><tt><font color=#666666>M</font></tt></td>
 		<td align='right'><tt>$bandfree</tt><tt><font color=#666666>M</font></tt></td>
		<td><tt>&nbsp;</tt></td>
 		|;
	}
#	print "<TD><table width='100%' border='0' cellspacing='0' cellpadding='0'>";
	print "<td><table class='blank' style='width: 150px; border: 1px #505050 solid;'>";
	if (int($bandper) < 1) {
		print "<td bgcolor='$graphbgcolour' width='1%' align='center'><tt>$bandper%</tt></td>";
	} else {
		print "<td bgcolor='$graphbgcolour' width='$bandper%' align='center'><tt>$bandper%</tt></td>";
	}
 
	if (int($bandper) < 100) {
		print "<td bgcolor='$graphblankcolour'>&nbsp;</td>";
	} else{
		print "<td bgcolor='$graphbgcolour'>&nbsp;</td>";
	}
	print "</table></TD>";
#	print "<TD><table width='100%' border='0' cellspacing='0' cellpadding='0'>";
	print "<td><table class='blank' style='width: 150px; border: 1px #505050 solid;'>";
	if (int($bandover) > 0) {
		print "<td bgcolor='$bandoverbgcolor' width='$bandover%' align='center'><tt><font color='$bandoverfontcolor'>+$bandover%</font></tt></td>";
	}
 
	if (int($bandover) < 100) {
		print "<td bgcolor='$graphblankcolour'>&nbsp;</td>";
	} else {
		print "<td bgcolor='$bandoverbgcolor'>&nbsp;</td>";
	}
	print "</table></TD>";
	print "</TR>";

	###print GREEN###
	print qq|
	<tr>
	<td align='left'><tt><font color='$catgreen'>GREEN</font>&nbsp;($netsettings{'GREEN_DEV'})</tt></td>
	<td align='right'><tt>-</tt><tt><font color=#666666> </font></tt></td>
	<td align='right'><tt>$greenbandin</tt><tt><font color=#666666>M</font></tt></td>
	<td align='right'><tt>$greenbandout</tt><tt><font color=#666666>M</font></tt></td>
	<td align='right'><tt>$greenbandtot</tt><tt><font color=#666666>M</font></tt></td>
	<td align='right'><tt>-</tt><tt><font color=#666666> </font></tt></td>
	<td><tt>&nbsp;</tt></td>
	<td><tt>&nbsp;</tt></td>
	<td><tt>&nbsp;</tt></td>
	</tr>
	|;

	###print ORANGE###
	if ($orangebandtot eq "0") {
#	if ($orangebandtot eq "1") {	###debugging
 		###then do nothing
	} else {
		print qq|
 		<tr>
		<td align='left'><tt><font color='$catorange'>ORANGE</font>&nbsp;($netsettings{'ORANGE_DEV'})</tt></td>
		<td align='right'><tt>-</tt><tt><font color=#666666> </font></tt></td>
		<td align='right'><tt>$orangebandin</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>$orangebandout</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>$orangebandtot</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>-</tt><tt><font color=#666666> </font></tt></td>
		<td><tt>&nbsp;</tt></td>
		<td><tt>&nbsp;</tt></td>
		<td><tt>&nbsp;</tt></td>
		</tr>
		|;
	}

	###print PURPLE###
	if ($purplebandtot eq "0") {
#	if ($purplebandtot eq "1") {	###debugging
 		###then do nothing
	} else {
		print qq|
 		<tr>
		<td align='left'><tt><font color='$catpurple'>PURPLE</font>&nbsp;($netsettings{'PURPLE_DEV'})</tt></td>
		<td align='right'><tt>-</tt><tt><font color=#666666> </font></tt></td>
		<td align='right'><tt>$purplebandin</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>$purplebandout</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>$purplebandtot</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>-</tt><tt><font color=#666666> </font></tt></td>
		<td><tt>&nbsp;</tt></td>
		<td><tt>&nbsp;</tt></td>
		<td><tt>&nbsp;</tt></td>
		</tr>
		|;
	}
}

sub bandGRAPHcolorsnow { ###color graph routine inspired by advstatus.cgi by The Smoothwall Team
	if (int($bandgraphper) > $graphalertcritical) {
		$graphbgcolour = $graphcriticalcolour;
	} elsif (int($bandgraphper) > $graphalertwarning) {
		$graphbgcolour = $graphwarningcolour;
	} elsif (int($bandgraphper) > 0) {
		$graphbgcolour = $graphnominalcolour;
	} else {
		$graphbgcolour = $graphblankcolour;
	}
}

sub bandviewGETusers {
	if (-e $bandviewsettings{'BAND_USERLIST'}) {
		@bandviewUSERS = `cat $bandviewsettings{'BAND_USERLIST'}`;
#		@bandviewUSERS = `cat /var/smoothwall/mods/bandview/preferences/bandview-userlist`;
		for ($i=0; $i <= $#bandviewUSERS; $i++){
			chomp ($bandviewUSERS[$i]);
			my @bandviewmembership = split(/\,/,$bandviewUSERS[$i]);
			$bandviewUSERS[$i] = $bandviewmembership[0];
			$bandviewUSERScap[$i] = $bandviewmembership[2];
			$bandviewUSERSipaddr[$i] = $bandviewmembership[1];
			$bandviewUSERSinfo[$i] = $bandviewmembership[3];
		}
	}
}

sub bandviewPRINTmonthuser {
	print "<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>";	###skip a row
#	print "<table border='0' cellspacing='0' cellpadding='2'>";
#	print "<table style='width: 95%; margin-left: auto; margin-right: auto; border-collapse: collapse; border: solid 1px #c0c0c0;'>";
	print qq|
	<tr>
	<th style='text-align: left;'>User</th>
	<th style='text-align: right;'>Cap</th>
	<th style='text-align: right;'>In</th>
	<th style='text-align: right;'>Out</th>
	<th style='text-align: right;'>Used</th>
	<th style='text-align: right;'>Left</th>
	<th style='text-align: right;'>&nbsp;</th>
	<th style='text-align: center;'>Used %</th>
	<th style='text-align: center;'>Over %</th>
	</tr>
	|;
	for ($i=0; $i <= $#bandviewUSERSipaddr; $i++) {
		&bandCALCULATIONSusermonth();
#		if (($userbandtot[$i] eq "0") || ($userbandtot[$i] eq "")) {	###hide if null or zero
#		if (($userbandtot[$i] eq "") || ($userbandtot[$i] eq "0") && ($userbandin[$i] eq "0") && ($userbandout[$i] eq "0")) {	###hide if null or triple-zero
		if (($userbandtot[$i] eq "") || ($userbandtot[$i] eq "0") && ($userbandin[$i] eq "") && ($userbandout[$i] eq "")) {	###hide if null
			### then do nothing
		} elsif (($bandviewsettings{'BAND_HIDETRIPLEZEROES'} eq "on") && ($userbandin[$i] eq "0") && ($userbandout[$i] eq "0")) {	###hide triple-zeroes
			### then do nothing
		} else {
			if ($userbandmax eq 0) {
 				print qq|
 				<tr>
				<td style='cursor: pointer' title="$bandviewUSERSipaddr[$i] - $bandviewUSERSinfo[$i]" align='left'><tt><font color=#00000>$bandviewUSERS[$i]</font></tt></td>
				<td align='right'><tt>-</tt><tt><font color=#666666> </font></tt></td>
				<td align='right'><tt>$userbandin[$i]</tt><tt><font color=#666666>M</font></tt></td>
				<td align='right'><tt>$userbandout[$i]</tt><tt><font color=#666666>M</font></tt></td>
				<td align='right'><tt>$userbandtot[$i]</tt><tt><font color=#666666>M</font></tt></td>
				<td align='right'><tt>-</tt><tt><font color=#666666> </font></tt></td>
				<td><tt>&nbsp;</tt></td>
				|;
			} else {
				print qq|
				<tr>
				<td style='cursor: pointer' title="$bandviewUSERSipaddr[$i] - $bandviewUSERSinfo[$i]" align='left'><tt><font color=#00000>$bandviewUSERS[$i]</font></tt></td>
				<td align='right'><tt>$userbandmax</tt><tt><font color=#666666>M</font></tt></td>
				<td align='right'><tt>$userbandin[$i]</tt><tt><font color=#666666>M</font></tt></td>
				<td align='right'><tt>$userbandout[$i]</tt><tt><font color=#666666>M</font></tt></td>
 				<td align='right'><tt>$userbandtot[$i]</tt><tt><font color=#666666>M</font></tt></td>
				<td align='right'><tt>$userbandfree[$i]</tt><tt><font color=#666666>M</font></tt></td>
				<td><tt>&nbsp;</tt></td>
				|;
			}
			$bandgraphper=$userbandper[$i]; &bandGRAPHcolorsnow();
#			print "<TD><table width='100%' border='0' cellspacing='0' cellpadding='0'>\n";
			print "<td><table class='blank' style='width: 150px; border: 1px #505050 solid;'>";
			if (int($userbandper[$i]) < 1) {
#				print "<td bgcolor='$graphbgcolour' width='1%' align='center'><tt>$userbandper[%i]%</tt></td>\n";
				print "<td bgcolor='$graphbgcolour' width='1%' align='center'><tt>0%</tt></td>\n";
			} else {
				print "<td bgcolor='$graphbgcolour' width='$userbandper[$i]%' align='center'><tt>$userbandper[$i]%</tt></td>\n";
			}
			if (int($userbandper[$i]) < 100) {
				print "<td bgcolor='$graphblankcolour'>&nbsp;</td>\n";
			} else {
				print "<td bgcolor='$graphbgcolour'>&nbsp;</td>\n";
			}
    			print "</table></TD>\n";
#			print "<TD><table width='100%' border='0' cellspacing='0' cellpadding='0'>\n";
			print "<td><table class='blank' style='width: 150px; border: 1px #505050 solid;'>";
			if (int($userbandover[$i]) > 0) {
				print "<td bgcolor='$bandoverbgcolor' width='$userbandover[$i]%' align='center'><tt><font color='$bandoverfontcolor'>+$userbandover[$i]%</font></tt></td>\n";
			}
			if (int($userbandover[$i]) < 100) {
				print "<td bgcolor='$graphblankcolour'>&nbsp;</td>\n";
			} else {
				print "<td bgcolor='$bandoverbgcolor'>&nbsp;</td>\n";
			}
			print "</table></TD>\n";
			print "</TR>\n";
		}
	}
	print qq|
	<tr>
	<td align='left'><tt><font color=#666666>User totals</font></tt></td>
	<td align='right'><tt>-</tt><tt><font color=#666666> </font></tt></td>
	<td align='right'><tt>$userbandtotalin</tt><tt><font color=#666666>M</font></tt></td>
	<td align='right'><tt>$userbandtotalout</tt><tt><font color=#666666>M</font></tt></td>
	<td align='right'><tt>$userbandtotalused</tt><tt><font color=#666666>M</font></tt></td>
	<td align='right'><tt>-</tt><tt><font color=#666666> </font></tt></td>
	<td><tt>&nbsp;</tt></td>
	<td><tt>&nbsp;</tt></td>
	<td><tt>&nbsp;</tt></td>
	</tr>
	|;
#	print "</table><br/>";
}

sub bandCALCULATIONSusermonth {
	$userbandmax = $bandviewUSERScap[$i];
	$userbandtot[$i]=$userbandin[$i]+$userbandout[$i];
	if ($bandviewsettings{'BAND_CALCULATEWHAT'} eq 'inonly') {
		$userbandfree[$i]=$userbandmax-$userbandin[$i];
		$userbandtot[$i]=$userbandin[$i]
	} elsif ($bandviewsettings{'BAND_CALCULATEWHAT'} eq 'outonly') {
		$userbandfree[$i]=$userbandmax-$userbandout[$i];
		$userbandtot[$i]=$userbandout[$i]
	} else {
		$userbandfree[$i]=$userbandmax-$userbandtot[$i];
	}
	$userbandtotalin=$userbandtotalin+$userbandin[$i];
	$userbandtotalout=$userbandtotalout+$userbandout[$i];
	$userbandtotalused=$userbandtotalused+$userbandtot[$i];
	if ($userbandmax eq 0) {
		$userbandper[$i] = 0;
	} else {
		if ($bandviewsettings{'BAND_CALCULATEWHAT'} eq 'inonly') {
			$userbandper[$i] = int((($userbandin[$i]/$userbandmax)*100));
		} elsif ($bandviewsettings{'BAND_CALCULATEWHAT'} eq 'outonly') {
			$userbandper[$i] = int((($userbandout[$i]/$userbandmax)*100));
		} else {
			$userbandper[$i] = int((($userbandtot[$i]/$userbandmax)*100));
		}
	}
	if ($userbandper[$i] >= 100){ $userbandover[$i]=$userbandper[$i]-100; $userbandper[$i]=100; };
}

sub bandviewTABinfo {	###code adapted from graphs.cgi by The Smoothwall Team
	my @values = split(/&/, $ENV{'QUERY_STRING'});
	foreach my $t (@values)
	{
		($varname, $mydata) = split(/=/, $t);
	        if ($varname eq 't'){ $bandviewtabnumber = $mydata; };
	}
}

sub bandviewMAINmenuZERO {	###bandview tabs!
&openbox;
#	print "<TABLE border='0' cellspacing='0' cellpadding='0'>";
	print "<TABLE width='100%' border='0' cellspacing='0' cellpadding='0'>";
#	print "<table style='width: 95%; margin-left: auto; margin-right: auto; border-collapse: collapse; border: solid 1px #c0c0c0;'>";
#	print "<table style='width: 97%; margin-left: auto; margin-right: auto; border-collapse: collapse;'>";
	print "<tr>";
	$bandviewtabwidth = int(100/($#bandviewtablabel+1))."%";	###bandview tabs!
	for ($i=0; $i <= $#bandviewtablabel; $i++) {
		$j=$i+1;
		if ($bandviewtabnumber == $j) {
			$bandtabcolor=$bandviewsettings{'BAND_TABSELECTED'};
		} elsif (($bandviewtabnumber == '') && ($j == 1)) {
			$bandtabcolor=$bandviewsettings{'BAND_TABSELECTED'};
		} else {
			$bandtabcolor=$bandviewsettings{'BAND_TABNOTSELECTED'};
		}
		print qq|
		<td width="$bandviewtabwidth" bgcolor="$bandtabcolor">
		<center>&nbsp;<a href="/cgi-bin/bandview.cgi?t=$j">$bandviewtablabel[$i]</a>&nbsp;</center>
		</td>
		|;
		if ($i ne $#bandviewtablabel){ print "<td> |</td>";}; #only print divider in between options
	}
	print "</tr></table>";
&closebox;

	if ($bandviewtabnumber eq '2') {
		&bandviewMAINmenuTWO();
	} elsif ($bandviewtabnumber eq '3') {
		&bandviewMAINmenuTHREE();
#	} elsif ($bandviewtabnumber eq '4') {
#		&bandviewMAINmenuFOUR();
	} else {
		&bandviewMAINmenuONE();
	}
}

sub bandviewMAINmenuONE {
&openbox("Bandview:<br>");
	print "<FORM METHOD='POST'>\n";
	print "<TABLE WIDTH='100%'>";
	print "<TR>";
 	print qq|
	<TD CLASS='base'>ISP cap:
	<SELECT NAME='BAND_ALLOTTED'>
		<OPTION VALUE='0' $selected{'BAND_ALLOTTED'}{'0'}>None
		<OPTION VALUE='500' $selected{'BAND_ALLOTTED'}{'500'}>.5 G
		<OPTION VALUE='1000' $selected{'BAND_ALLOTTED'}{'1000'}>1 G
		<OPTION VALUE='2000' $selected{'BAND_ALLOTTED'}{'2000'}>2 G
		<OPTION VALUE='3000' $selected{'BAND_ALLOTTED'}{'3000'}>3 G
		<OPTION VALUE='4000' $selected{'BAND_ALLOTTED'}{'4000'}>4 G
		<OPTION VALUE='5000' $selected{'BAND_ALLOTTED'}{'5000'}>5 G
		<OPTION VALUE='6000' $selected{'BAND_ALLOTTED'}{'6000'}>6 G
		<OPTION VALUE='7000' $selected{'BAND_ALLOTTED'}{'7000'}>7 G
		<OPTION VALUE='8000' $selected{'BAND_ALLOTTED'}{'8000'}>8 G
		<OPTION VALUE='9000' $selected{'BAND_ALLOTTED'}{'9000'}>9 G
		<OPTION VALUE='10000' $selected{'BAND_ALLOTTED'}{'10000'}>10 G
		<OPTION VALUE='11000' $selected{'BAND_ALLOTTED'}{'11000'}>11 G
		<OPTION VALUE='12000' $selected{'BAND_ALLOTTED'}{'12000'}>12 G
		<OPTION VALUE='13000' $selected{'BAND_ALLOTTED'}{'13000'}>13 G
		<OPTION VALUE='14000' $selected{'BAND_ALLOTTED'}{'14000'}>14 G
		<OPTION VALUE='15000' $selected{'BAND_ALLOTTED'}{'15000'}>15 G
		<OPTION VALUE='16000' $selected{'BAND_ALLOTTED'}{'16000'}>16 G
		<OPTION VALUE='17000' $selected{'BAND_ALLOTTED'}{'17000'}>17 G
		<OPTION VALUE='18000' $selected{'BAND_ALLOTTED'}{'18000'}>18 G
		<OPTION VALUE='19000' $selected{'BAND_ALLOTTED'}{'19000'}>19 G
		<OPTION VALUE='20000' $selected{'BAND_ALLOTTED'}{'20000'}>20 G
       	<OPTION VALUE='25000' $selected{'BAND_ALLOTTED'}{'25000'}>25 G
		<OPTION VALUE='30000' $selected{'BAND_ALLOTTED'}{'30000'}>30 G
		<OPTION VALUE='35000' $selected{'BAND_ALLOTTED'}{'35000'}>35 G
		<OPTION VALUE='40000' $selected{'BAND_ALLOTTED'}{'40000'}>40 G
		<OPTION VALUE='45000' $selected{'BAND_ALLOTTED'}{'45000'}>45 G
		<OPTION VALUE='50000' $selected{'BAND_ALLOTTED'}{'50000'}>50 G
		<OPTION VALUE='60000' $selected{'BAND_ALLOTTED'}{'60000'}>60 G
		<OPTION VALUE='70000' $selected{'BAND_ALLOTTED'}{'70000'}>70 G
		<OPTION VALUE='80000' $selected{'BAND_ALLOTTED'}{'80000'}>80 G
		<OPTION VALUE='90000' $selected{'BAND_ALLOTTED'}{'90000'}>90 G
		<OPTION VALUE='100000' $selected{'BAND_ALLOTTED'}{'100000'}>100 G
		<OPTION VALUE='200000' $selected{'BAND_ALLOTTED'}{'200000'}>200 G
		<OPTION VALUE='250000' $selected{'BAND_ALLOTTED'}{'250000'}>250 G
       </SELECT>
	<TD CLASS='base'>Calculate usage:
	<SELECT NAME='BAND_CALCULATEWHAT'>
		<OPTION VALUE='both' $selected{'BAND_CALCULATEWHAT'}{'both'}>In and Out
		<OPTION VALUE='inonly' $selected{'BAND_CALCULATEWHAT'}{'inonly'}>In Only
		<OPTION VALUE='outonly' $selected{'BAND_CALCULATEWHAT'}{'outonly'}>Out Only
       </SELECT>
	</td>
	<TD WIDTH CLASS='base'>Hide zeroes:<INPUT TYPE='checkbox' NAME='BAND_HIDETRIPLEZEROES' $checked{'BAND_HIDETRIPLEZEROES'}{'on'}></TD>
	|;
	&bandviewSAVEtab2SETTINGS();
	print qq|
	<TD ALIGN='CENTER'><INPUT TYPE='submit' NAME='ACTION' VALUE='Apply'></TD>
	|;
	print "</tr></TABLE>";
&closebox();
	&bandviewGETDATAmonth();
	&bandviewCALCULATIONSmonth();
	my $timestamp = 'N/A';
	if ($bandlastupdate) { $timestamp = strftime "%a %b %e %H:%M:%S %Y", localtime($bandlastupdate); }
&openbox("Monthly Monitor - ${timestamp}:<br>");
	&bandviewPRINTmonth();
	&bandviewPRINTmonthuser();
	if ($bandviewsettings{'BAND_DAYSINFO'} eq "on") {	### show day info
		&bandviewCALCULATEdaysused();
		&bandviewPRINTdaysused();
		&bandviewCALCULATEdayaverage();
		&bandviewPRINTdayaverage();
	} else {
		print "</table><br/>";	### close things up if day info isn't shown
	}
&closebox();
}

sub bandviewMAINmenuFOUR {
&openbox();
	print "<table><tr>menuFOUR</tr></table>";
&closebox();
}

sub bandviewMAINmenuTHREE {
&openbox("/var/log/trafficstats:<br>");
		print "<table width='100%' border='0' cellspacing='2' cellpadding=''>";
		$v=0;
		@trafficstatsdata = `cat /var/log/trafficstats`;
		my ( $table1colour, $table2colour ) = ( '#f0f0f0', '#e0e0e0' );
		for ($i=0; $i <= $#trafficstatsdata; $i++) {
			$raw = $trafficstatsdata[$i];
			if ($v eq $i) {
				print "<TR BGCOLOR=$table1colour><TD><TT><font color=#000000>$raw</FONT></TT></TD></TR>";
				$v=$v+2;
			} else {
				print "<TR BGCOLOR=$table2colour><TD><TT><font color=#000000>$raw</FONT></TT></TD></TR>";
			}
		}
		print "</table>";

&closebox();
}

sub bandviewMAINmenuTWO {
&openbox("Add users:");
	print "<FORM METHOD='POST'>";
	print "<TABLE WIDTH='100%'>";
	print "<TR>";
# 	print "$bandviewsettings{'BAND_COMPUTERNAME'} / $bandviewsettings{'BAND_INDIVIDUALCAP'} / $bandviewsettings{'BAND_USERCOMMENT'} / $bandviewsettings{'BAND_COMPUTERIP'} / $bandviewsettings{'BAND_RANGESTART'} / $bandviewsettings{'BAND_RANGEFINISH'}";	###debugging
	print qq|
	<TD CLASS='base'>Username: <INPUT TYPE='text' NAME='BAND_COMPUTERNAME' SIZE=16 MAXLENGTH=15 VALUE='$bandviewsettings{'BAND_COMPUTERNAME'}'></TD>
	<TD CLASS='base'>User cap: <INPUT TYPE='text' NAME='BAND_INDIVIDUALCAP' SIZE=6 MAXLENGTH=6 VALUE='$bandviewsettings{'BAND_INDIVIDUALCAP'}'></TD>
	<TD CLASS='base'>Description: <INPUT TYPE='text' NAME='BAND_USERCOMMENT' SIZE=21 MAXLENGTH=20 VALUE='$bandviewsettings{'BAND_USERCOMMENT'}'></TD>
	<TD WIDTH='5%' ALIGN='RIGHT' COLSPAN='2'><INPUT TYPE='submit' NAME='ACTION' VALUE='$tr{'add'}'></TD>
	</TR>
	</TABLE>
	<TABLE WIDTH='100%'>
	<TR>
	<TD CLASS='base'>
	IP address: <INPUT TYPE='text' NAME='BAND_COMPUTERIP' SIZE=15 MAXLENGTH=15 VALUE='$bandviewsettings{'BAND_COMPUTERIP'}'>
	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
	<B>OR</B>
	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
	IP range: <INPUT TYPE='text' NAME='BAND_RANGESTART' SIZE=15 MAXLENGTH=15 VALUE='$bandviewsettings{'BAND_RANGESTART'}'> - xxx.xxx.xxx.<INPUT TYPE='text' NAME='BAND_RANGEFINISH' SIZE=3 MAXLENGTH=3 VALUE='$bandviewsettings{'BAND_RANGEFINISH'}'>
	</TD>
	</TR>
	</TABLE>
	|;
&closebox();
&openbox("Current user list:");
	if (-e $bandviewsettings{'BAND_USERLIST'}) {
		@bandviewusers = `cat $bandviewsettings{'BAND_USERLIST'}`;
		chomp (@bandviewusers);
	}
	print "<TABLE WIDTH='100%'>";
	print "<tr>";
#	print "$bandviewsettings{'BAND_COLUMN'} / $bandviewsettings{'BAND_REVERSE'}"; ###debugging
	print qq|
	<TD CLASS='base'>Sort by:
	<SELECT NAME='BAND_COLUMN'>
		<OPTION VALUE='0' $selected{'BAND_COLUMN'}{'0'}>None
		<OPTION VALUE='1' $selected{'BAND_COLUMN'}{'1'}>Username
		<OPTION VALUE='5' $selected{'BAND_COLUMN'}{'5'}>IP Address
		<OPTION VALUE='3' $selected{'BAND_COLUMN'}{'3'}>User Cap
		<OPTION VALUE='4' $selected{'BAND_COLUMN'}{'4'}>Description
	</SELECT>
	</TD>
	<TD CLASS='base'>Reverse sort:
	<INPUT TYPE='checkbox' NAME='BAND_REVERSE' $checked{'BAND_REVERSE'}{'on'}>
	</TD>
	|;
	&bandviewSAVEtab1SETTINGS();
	print qq|
	<TD ALIGN='RIGHT'><INPUT TYPE='submit' NAME='ACTION' VALUE='Refresh'></TD>
	|;
	print "</tr></TABLE>";
	print qq|
	<br>
	<table class='list'>
	<tr>
	<th class='list' style='width: 25%; $colour'>Username</TD>
	<th class='list' style='width: 25%; $colour'>IP address</TD>
	<th class='list' style='width: 25%; $colour'>User cap</TD>
	<th class='list' style='width: 25%; $colour'>Description</TD>
	<th class='list' style='width: 5%; $colour'>Mark</TD>
	</TR>
	|;
	if (-e $bandviewsettings{'BAND_USERLIST'}) {
		###START###some code adapted from dhcp.cgi by The Smoothwall Team
		my $id = 0;
		open(USERLIST, "$bandviewsettings{'BAND_USERLIST'}") or die 'Unable to open config file.';
		while (<USERLIST>)
		{
			print "<tr class='list'>";
			$id++;
			chomp($_);
			my @temp = split(/\,/,$_);
			if ($id % 2)
			{
				$table2colour = '#f0f0f0';
			} 
			else 
			{
				$table2colour = '#e0e0e0';
			}
			my $colour = "background-color: $table2colour;";		
			print qq|
			<td class='list' style='$colour'>$temp[0]</TD>
			<td class='list' style='$colour'>$temp[1]</TD>
			<td class='list' style='$colour'>$temp[2]</TD>
			<td class='list' style='$colour'>$temp[3]</TD>
			<td class='list' style='$colour'><INPUT TYPE='CHECKBOX' NAME='$id'></TD>
			</tr>
			|;
		}
		close(USERLIST);
		###END###some code adapted from dhcp.cgi by The Smoothwall Team
	}
	print "</TABLE>";
	print "<TABLE WIDTH='100%'>";
	print "<TR>";
	print qq|
		<TD WIDTH='50%' ALIGN='CENTER'><INPUT TYPE='SUBMIT' NAME='ACTION' VALUE='Remove'></TD>
		<TD WIDTH='50%' ALIGN='CENTER'><INPUT TYPE='SUBMIT' NAME='ACTION' VALUE='Edit'></TD>
	|;
	print "</TR>";
	print "</TABLE>";
	print "</FORM>";
&closebox();
}

sub bandviewACTIONupdate {
	if ($bandviewsettings{'ACTION'} eq "Apply") {
		&writehash("${swroot}/mods/bandview/preferences/bandview", \%bandviewsettings);
	}
	if ($bandviewsettings{'ACTION'} eq "Update") {
		&writehash("${swroot}/mods/bandview/preferences/bandview", \%bandviewsettings);
	}
	if ($bandviewsettings{'ACTION'} eq "Refresh") {
		&bandviewSORTING();
		&writehash("${swroot}/mods/bandview/preferences/bandview", \%bandviewsettings);
	}
}

sub bandviewUSERadd {	###some code adapted from dhcp.cgi by The Smoothwall Team
#	chomp($bandviewsettings{'BAND_RANGESTART'});
	my @temprangestart = split(/\./,$bandviewsettings{'BAND_RANGESTART'});
	$prefixofip="$temprangestart[0].$temprangestart[1].$temprangestart[2].";
	$prefixwithfinish="$prefixofip$bandviewsettings{'BAND_RANGEFINISH'}";

	if ($bandviewsettings{'ACTION'} eq $tr{'add'}) {
		unless ($bandviewsettings{'BAND_COMPUTERNAME'}) { $errormessage = "please enter a username"; }
		unless ($bandviewsettings{'BAND_COMPUTERNAME'} =~ /^\w+$/) { $errormessage = "username contains bad characters"; }
		if ($bandviewsettings{'BAND_COMPUTERNAME'} =~ /[\,\n]/) { $errormessage = "username contains bad characters"; }
		if ($bandviewsettings{'BAND_COMPUTERNAME'} =~ /[\.\n]/) { $errormessage = "username contains bad characters"; }
		if ($bandviewsettings{'BAND_RANGESTART'} || $bandviewsettings{'BAND_RANGEFINISH'}) {	###ip range support
#			unless(&validip($bandviewsettings{'BAND_RANGESTART'})) { $errormessage = "$bandviewsettings{'BAND_RANGESTART'} start ip address range not valid"; }
			unless(&validip($bandviewsettings{'BAND_RANGESTART'})) { $errormessage = "start ip address range not valid"; }
#			unless(&validip($prefixwithfinish)) { $errormessage = "$prefixwithfinish end ip address range not valid"; }
			unless(&validip($prefixwithfinish)) { $errormessage = "end ip address range not valid"; }
#			if ($temprangestart[3] > $bandviewsettings{'BAND_RANGEFINISH'}) { $errormessage = "$temprangestart[3] $bandviewsettings{'BAND_RANGEFINISH'} ip address range not valid"; }
			if ($temprangestart[3] > $bandviewsettings{'BAND_RANGEFINISH'}) { $errormessage = "ip address range not valid"; }
		} else {
			unless(&validip($bandviewsettings{'BAND_COMPUTERIP'})) { $errormessage = $tr{'ip address not valid'}; }
		}
		unless ($bandviewsettings{'BAND_INDIVIDUALCAP'} =~ /^\d+$/) { $errormessage = "user cap can only contain numbers"; }
		if ($bandviewsettings{'BAND_INDIVIDUALCAP'} =~ /[\,\n]/) { $errormessage = "user cap contains bad characters"; }
		if ($bandviewsettings{'BAND_INDIVIDUALCAP'} =~ /[\.\n]/) { $errormessage = "user cap contains bad characters"; }
		unless ($bandviewsettings{'BAND_USERCOMMENT'} =~ /^([a-zA-Z])+([\.a-zA-Z0-9_-])+$/) { $errormessage = "description contains bad characters"; }
		if ($bandviewsettings{'BAND_USERCOMMENT'} =~ /[\,\n]/) { $errormessage = "description contains bad characters"; }
		unless ($errormessage) {
			open(FILE, ">>$bandviewsettings{'BAND_USERLIST'}") or die 'Unable to open userlist file.';
			flock FILE, 2;
		if ($bandviewsettings{'BAND_RANGESTART'} && $bandviewsettings{'BAND_RANGEFINISH'}) {	###ip range support
			for ($i=$temprangestart[3]; $i <= $bandviewsettings{'BAND_RANGEFINISH'}; $i++) {
				$prefixwithip = "$prefixofip$i";
				print FILE "$bandviewsettings{'BAND_COMPUTERNAME'}$i,$prefixwithip,$bandviewsettings{'BAND_INDIVIDUALCAP'},$bandviewsettings{'BAND_USERCOMMENT'},".&ip2number($prefixwithip)."\n";
			}
		} else {
			print FILE "$bandviewsettings{'BAND_COMPUTERNAME'},$bandviewsettings{'BAND_COMPUTERIP'},$bandviewsettings{'BAND_INDIVIDUALCAP'},$bandviewsettings{'BAND_USERCOMMENT'},".&ip2number($bandviewsettings{'BAND_COMPUTERIP'})."\n";
		}
			close(FILE);
			delete $bandviewsettings{'BAND_COMPUTERNAME'};
			delete $bandviewsettings{'BAND_COMPUTERIP'};
			delete $bandviewsettings{'BAND_INDIVIDUALCAP'};
			delete $bandviewsettings{'BAND_USERCOMMENT'};
			delete $bandviewsettings{'BAND_RANGESTART'};
			delete $bandviewsettings{'BAND_RANGEFINISH'};
		}
	}
}

sub bandviewUSERremoveEDIT {	###some code adapted from dhcp.cgi by The Smoothwall Team
	if ($bandviewsettings{'ACTION'} eq $tr{'remove'} || $bandviewsettings{'ACTION'} eq $tr{'edit'}) 
	{
		open(FILE, "$bandviewsettings{'BAND_USERLIST'}") or die 'Unable to open config file.';
		my @current = <FILE>;
		close(FILE);
		my $count = 0;
		my $id = 0;
		my $line;
		foreach $line (@current)
		{
			$id++;
			if ($bandviewsettings{$id} eq "on") { $count++; };	###count of how many are selected
		}
		if ($count == 0) {
			$errormessage = $tr{'nothing selected'}; }
		if ($count > 1 && $bandviewsettings{'ACTION'} eq $tr{'edit'}) {
			$errormessage = $tr{'you can only select one item to edit'}; }
		unless ($errormessage)
		{
			open(USERLIST, ">$bandviewsettings{'BAND_USERLIST'}") or die 'Unable to open config file.';
			flock USERLIST, 2;
 			$id = 0;
			foreach $line (@current)
			{
				$id++;
				unless ($bandviewsettings{$id} eq "on") {
					print USERLIST "$line"; }
				elsif ($bandviewsettings{'ACTION'} eq $tr{'edit'})
				{
					chomp($line);
					my @temp = split(/\,/,$line);
					$bandviewsettings{'BAND_COMPUTERNAME'} = $temp[0];
					$bandviewsettings{'BAND_COMPUTERIP'} = $temp[1];
					$bandviewsettings{'BAND_INDIVIDUALCAP'} = $temp[2];
					$bandviewsettings{'BAND_USERCOMMENT'} = $temp[3];
				}
			}
			close(USERLIST);
		}
	}
}

sub bandviewSORTING {
	if (($bandviewsettings{'BAND_REVERSE'} ne "on") && ($bandviewsettings{'BAND_COLUMN'} ne "0")) {
		if ($bandviewsettings{'BAND_COLUMN'} eq '5' | $bandviewsettings{'BAND_COLUMN'} eq '3') {
			system ("/bin/sort $bandviewsettings{'BAND_USERLIST'} -n -k $bandviewsettings{'BAND_COLUMN'}.1 -t , -o $bandviewsettings{'BAND_USERLIST'}");
		} else {
			system ("/bin/sort $bandviewsettings{'BAND_USERLIST'} -k $bandviewsettings{'BAND_COLUMN'}.1 -t , -o $bandviewsettings{'BAND_USERLIST'}");
		}
	} elsif (($bandviewsettings{'BAND_REVERSE'} eq "on") && ($bandviewsettings{'BAND_COLUMN'} ne "0")) {
		if ($bandviewsettings{'BAND_COLUMN'} eq '5' | $bandviewsettings{'BAND_COLUMN'} eq '3') {
			system ("/bin/sort $bandviewsettings{'BAND_USERLIST'} -n -k $bandviewsettings{'BAND_COLUMN'}.1 -t , -r -o $bandviewsettings{'BAND_USERLIST'}");
		} else {
			system ("/bin/sort $bandviewsettings{'BAND_USERLIST'} -k $bandviewsettings{'BAND_COLUMN'}.1 -t , -r -o $bandviewsettings{'BAND_USERLIST'}");
		}
	}
}

sub ip2number {
	my $ip = $_[0];
	if (!($ip =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/)) {
		return 0; 
	} else {
		return ($1*(256*256*256))+($2*(256*256))+($3*256)+$4; 
	}
}

sub bandviewSAVEtab1SETTINGS {
	print qq|
	<INPUT TYPE='hidden' NAME='BAND_ALLOTTED' VALUE='$bandviewsettings{'BAND_ALLOTTED'}'>
	<INPUT TYPE='hidden' NAME='BAND_CALCULATEWHAT' VALUE='$bandviewsettings{'BAND_CALCULATEWHAT'}'>
	<INPUT TYPE='hidden' NAME='BAND_HIDETRIPLEZEROES' VALUE='$bandviewsettings{'BAND_HIDETRIPLEZEROES'}'>
	|;
}

sub bandviewSAVEtab2SETTINGS {
	print qq|
	<INPUT TYPE='hidden' NAME='BAND_COLUMN' VALUE='$bandviewsettings{'BAND_COLUMN'}'>
	<INPUT TYPE='hidden' NAME='BAND_REVERSE' VALUE='$bandviewsettings{'BAND_REVERSE'}'>
	|;
}

sub bandviewCALCULATEdaysused { ###DAYS USED mod contributed by Andrew Brown (andrewb)
	# Get date data for today
	$CurDate = (localtime(time()))[3];
	$CurMonth = (localtime(time()))[4] + 1;
	$CurYear = (localtime(time()))[5] + 1900;

	# Get Anniversary Day from
	$AnniversaryDay = $bandviewsettings{'BAND_ANNIVERSARY'};

	# Check if this is a leap year
	if ($CurYear eq ((int($CurYear/4))*4)) {
		$daysinmonth[1]=29;	# this is a leap year - February has 29 days
	}

	if ($CurDate < $AnniversaryDay) {
		$CurMonth = $CurMonth - 1;	# The EOM boundary has been crossed

		if ($CurMonth eq 0) {
			$CurMonth = 12;	# wraps to December last year
		}
		$monthdays = $daysinmonth[$CurMonth - 1];
		$monthused = $monthdays - $AnniversaryDay + $CurDate;
	} else {
		$monthdays = $daysinmonth[$CurMonth - 1];
		$monthused = $CurDate - $AnniversaryDay;
	}
	$monthleft = $monthdays - $monthused;
	$monthper = int((($monthused/$monthdays)*100));
}


sub bandviewCALCULATEdayaverage {
#	$monthused = 0;	###debugging
#	$monthleft = 0;	###debugging

	if ($monthused eq 0) {
		$monthused = 1;
	}
	$bandavgin = int($bandin/$monthused);
	$bandavgout = int($bandout/$monthused);
	$bandavgused = int($bandtot/$monthused);

	if ($bandmax eq 0) {
		###then do nothing
	} else {
		$bandavgcap = int($bandmax/$monthdays);
		
		if ($monthleft eq 0) {
			$monthleft = 1;	###prevent division by zero
		}
		$bandavgfree = int($bandfree/$monthleft);

#		if ($bandavgfree < 0) {
#			$bandavgfree=0;	###commented out to allow 'negative free'
#		}
	}
}

sub bandviewPRINTdaysused { ###DAYS USED mod contributed by Andrew Brown (andrewb)
	$bandgraphper=$monthper; &bandGRAPHcolorsnow();

	print "<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>";	###skip a row
#	print "<table border='0' cellspacing='0' cellpadding='2'>";
#	print "<table style='width: 95%; margin-left: auto; margin-right: auto; border-collapse: collapse; border: solid 1px #c0c0c0;'>";
	print qq|
	<tr>
	<th style='text-align: left;'>Miscellaneous</th>
	<th style='text-align: right;'>Cap</th>
	<th style='text-align: right;'>In</th>
	<th style='text-align: right;'>Out</th>
	<th style='text-align: right;'>Used</th>
	<th style='text-align: right;'>Left</th>
	<th style='text-align: right;'>&nbsp;</th>
	<th style='text-align: center;'>Used %</th>
	<th style='text-align: center;'>&nbsp;</th>
	</tr>
	|;

	###print DAYS USED###
	print qq|
	<tr>
	<td align='left'><tt><font color=#00000>DAYS USED</font></tt></td>
	<td align='right'><tt>$monthdays</tt><tt><font color=#666666>d</font></tt></td>
	<td align='right'><tt>-</tt><tt><font color=#666666> </font></tt></td>
	<td align='right'><tt>-</tt><tt><font color=#666666> </font></tt></td>	
	<td align='right'><tt>$monthused</tt><tt><font color=#666666>d</font></tt></td>
	<td align='right'><tt>$monthleft</tt><tt><font color=#666666>d</font></tt></td>
	<td align='right'><tt>&nbsp;</tt></td>
	|;

#	print "<TD><table width='100%' border='0' cellspacing='0' cellpadding='0'>\n";
	print "<td><table class='blank' style='width: 150px; border: 1px #505050 solid;'>";

	if (int($monthper) < 1) {
		print "<td bgcolor='$graphbgcolour' width='1%' align='center'><tt>$monthper%</tt></td>\n";
	} else {
		print "<td bgcolor='$graphbgcolour' width='$monthper%' align='center'><tt>$monthper%</tt></td>\n";
	}
 
	if (int($monthper) < 100) {
		print "<td bgcolor='$graphblankcolour'>&nbsp;</td>\n";
	} else {
		print "<td bgcolor='$graphbgcolour'>&nbsp;</td>\n";
	}
	
	print "</table></TD>\n";
	print "<td><tt>&nbsp;</tt></td>\n";
	print "</TR>\n";
}


sub bandviewPRINTdayaverage {
	###print Daily Averages###
	if ($bandmax eq 0) {
		print qq|
		<tr>
		<td align='left'><tt><font color=#00000>DAY AVERAGES</font></tt></td>
		<td align='right'><tt>-</tt><tt><font color=#666666> </font></tt></td>
		<td align='right'><tt>$bandavgin</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>$bandavgout</tt><tt><font color=#666666>M</font></tt></td>	
		<td align='right'><tt>$bandavgused</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>-</tt><tt><font color=#666666> </font></tt></td>
		<td><tt>&nbsp;</tt></td>
		<td><tt>&nbsp;</tt></td>
		<td><tt>&nbsp;</tt></td>
		</tr>
		|;
	} else {
		print qq|
		<tr>
		<td align='left'><tt><font color=#00000>DAY AVERAGES</font></tt></td>
		<td align='right'><tt>$bandavgcap</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>$bandavgin</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>$bandavgout</tt><tt><font color=#666666>M</font></tt></td>	
		<td align='right'><tt>$bandavgused</tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt>$bandavgfree</tt><tt><font color=#666666>M</font></tt></td>
		<td><tt>&nbsp;</tt></td>
		<td><tt>&nbsp;</tt></td>
		<td><tt>&nbsp;</tt></td>
		</tr>
		|;
	}
	print "</table><br/>";
}
