#!/usr/bin/perl
#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal
#
###2006-0422 - uninstall.pl from QoS v1.8 by NetWhiz modded by catastrophe for use with enhancedipblock v.0.2
# - Included v2.1 easymod routine from DHCP Pack by Tiago
###2007-0107 - modded by catastrophe for use with NoWireAP v.0.2.0
###2007-0914 - modded by catastrophe for use with Connview v.0.9
# - "check Smoothwall version" adapted from install script of Crontool v3.0c mod by s-t-p
###2007-1010 - modded by catastrophe for use with Bandview v.0.9
###2007-1015 - modded by catastrophe for use with Bandview v.0.9.1
###


# # # # # # #
# variables #
# # # # # # #

# modlib directories
my $bkp = '/var/smoothwall/mods/bandview/backup';
my $mod = '/var/smoothwall/mods/bandview/modfiles';	# mod files stored here
my $param = '/var/smoothwall/mods/bandview/params';	# modlib parameters stored here

require '/var/smoothwall/mods/bandview/modlib.pl';	# require modlib

# # # # # # # # # # # # # #
# check Smoothwall verson #
# # # # # # # # # # # # # #

if (!(-e "/usr/lib/smoothwall/langs/base.pl")) {
	print "\nYou are not running SmoothWall Express version 3.0\n \n";
	print "This version of the Bandview mod requires SWE 3.0\n \n";
	print "Terminating Bandview mod uninstallation.\n";
	exit;
}

# # # # # # # # # # # # # # # # # # #
# check for existing installations  #
# # # # # # # # # # # # # # # # # # #

print "\nUninstalling Bandview v.0.9.1, please wait...\n\n";

if (&installed ("/usr/lib/smoothwall/langs/base.pl", "# bandview v.0.9")) {
	print "\nPlease remove # bandview v.0.9 \n";
	print "Note - Run uninstall-090.pl script.\n \n";
	exit;
}

if (-e "/var/smoothwall/mods/bandview/installed") {
	if (&installed ("/var/smoothwall/mods/bandview/installed", "# bandview v.0.9")) {
		print "\nPlease remove # bandview v.0.9 \n";
		print "Note - Run uninstall-090.pl script.\n \n";
		exit;
	}
}


# # # # # # # # # # # #
# handle file copying #
# # # # # # # # # # # #

#	$storebkp =	where to store backup of the files that are changed by your mod
#	$moddir =	where your mod files are
#	$wkdir =	where you are changing files (backup from and copy to)
#
#	backupinstall ($file, $wkdir, $storebkp, $moddir);
#	backup ($file, $wkdir, $storebkp);
#	install ($file, $wkdir, $moddir);
#	uninstallrestore ($file, $wkdir, $storebkp);
#	uninstall ($file , $wkdir);
#
#	installed ($file, $string);
#
#	search for $string into $file => 1 found / 0 not found

$wkdir = '/httpd/cgi-bin';
&uninstall ('bandview.cgi', $wkdir);

$wkdir = '/httpd/html/help';
&uninstall ('bandview.cgi.html.en', $wkdir);

$wkdir = '/usr/lib/smoothwall/menu/1000_About';
&uninstall ('1516_bandview.list', $wkdir);

# # # # # # # # # # # #
# handle file editing #
# # # # # # # # # # # #

&easymod ("/httpd/cgi-bin/.htaccess", "$param/htaccess.09.d", '3', "/dev/null");

&easymod ("/usr/lib/smoothwall/langs/alertboxes.base.pl", "$param/alertboxes.base.pl.09.d", '1', "/dev/null");

&easymod ("/usr/lib/smoothwall/langs/base.pl", "$param/base.pl.091.d", '3', "/dev/null");

# # # # # # # # # # # #
# handle file linking #
# # # # # # # # # # # #

$dir = "/var/smoothwall/mods/bandview";
&uninstall ("installed", $dir);

print "\nDone\n\n";

# # # #
# end #
# # # #


sub easymod21		# from modlib v2.1
{
	my $targetfile = $_[0];
	my $searchfile = $_[1];
	my $linestodelete = $_[2];
	my $replacefile = $_[3];

	open(TARGET, "$targetfile") or die 'Unable to open target file.';
	my @target = <TARGET>;
	close(TARGET);

	open(SEARCH, "$searchfile") or die 'Unable to open search file';
	my @search = <SEARCH>;
	close(SEARCH);

	open(REPLACE, "$replacefile") or die 'Unable to open replace file.';
	my @replace = <REPLACE>;
	close(REPLACE);

	open(TEMP, ">/tmp/temp") or die 'Unable to open temporary file.';
	flock TEMP, 2;

	my $found = 0;
	my $line;
	foreach $line (@target)
	{
		if ($found == 0)
		{
			if ($line eq "@search")
			{
				$found = 1;
				if ($linestodelete > 0)
				{
					$linestodelete--;
				}
				else {print TEMP "$line"; }
				my $repline;
				foreach $repline (@replace) {print TEMP $repline; }
			}
			else {print TEMP "$line"; }
		}
		else
		{
			if ($linestodelete > 0)
			{
				$linestodelete--;
			}
			else {print TEMP "$line"; }
		}
	}	
	close(TEMP);
	system "/bin/cp /tmp/temp $targetfile";
	system "/bin/rm -f /tmp/temp";
}
